function A= gauss2q(s,j,n_voix,q)

%    A=gauss2q(x,j, n_voix,q); 
%Calcule le module de la transformee 
%en ondelettes continue (avec comme 
%ondelette la derivee a l'ordre q de 
%l'atome de Gauss) dans l'octave j 
%(j varie de 1 a log_2 (size(s))-1 )
%n_voix est le nombre de canaux. 

nn    = length(s);
shat = fft(s);
xi   = [ (0: (nn/2)) (((-nn/2)+1):-1) ] .* (2*pi); 

n_octaves = floor(log2(nn))-1; 	
n_echelles= n_voix .* n_octaves;
k_echelle=1;
echelle   = 2.^j;
B2= zeros(nn,n_voix);
for l = 0:n_voix-1,
    q_echelle = echelle .* (2^(l/n_voix));
    omega  = xi ./ q_echelle ;
    psi_hat =(omega.^q).* exp(-(omega.^2) ./2);
    w_hat = psi_hat .* shat;
    w    = ifft(w_hat);
    u2=abs(w);	
    B2(1:nn,k_echelle)=u2';
		   k_echelle = k_echelle+1;
 end 
 C=log(B2);   
 A=C';
		    
 